#Highly divisible triangular number

#The sequence of triangle numbers is generated by adding the natural 
# numbers. So the 7th triangle number would be 1 + 2 + 3 + 4 + 5 + 6 + 7 = 28. 
# The first ten terms would be:

#1, 3, 6, 10, 15, 21, 28, 36, 45, 55, ...

#Let us list the factors of the first seven triangle numbers:

# 1: 1
# 3: 1,3
# 6: 1,2,3,6
#10: 1,2,5,10
#15: 1,3,5,15
#21: 1,3,7,21
#28: 1,2,4,7,14,28
#We can see that 28 is the first triangle number to have over five divisors.

#What is the value of the first triangle number to have over five hundred divisors?

import time


def triangular_div(n):
    prime_divisor = 2  # minimum prime_divisor
    lst = []  # prime_divisor sheet
    multiplication = 1
    s = n * (n + 1) // 2  # triangular number
    while s != 1:
        if s % prime_divisor == 0:
            s = s // prime_divisor
            lst.append(prime_divisor)
        else:
            prime_divisor += 1
    for dig in set(lst):
        multiplication *= (lst.count(dig) + 1)
    if multiplication >= 500:
        return True
    else:
        return False


start = time.time()
i = 1
while True:
    if triangular_div(i):
        answer = ((i + 1) * i) // 2
        print(answer)
        break
    i += 2
    
print(time.time() - start)
# Time  - 1.478118896484375